{{- $distro := .distro -}}
{{- $suite := .suite -}}
{{- $repo_prefix := .repo_prefix -}}
{{- $radxa_mirror := .radxa_mirror -}}

{{- $debian_mirror := or .distro_mirror "https://deb.debian.org" -}}
{{- $debian_area := "main contrib non-free" -}}

{{ if eq $suite "bookworm" }}
{{- $debian_area = print $debian_area " non-free-firmware" -}}
{{ end }}

{{- $ubuntu_mirror := or .distro_mirror "http://ports.ubuntu.com" -}}
{{- $ubuntu_area := "main restricted universe multiverse" -}}

{{- $architecture := .architecture -}}

architecture: {{ $architecture }}

actions:
  - action: overlay
    description: Install apt policies
    source: overlays/apt
    destination: /

  - action: debootstrap
    suite: {{ $suite }}
    variant: minbase
    components:
      - main
{{ if eq $distro "debian" }}
      - contrib
      - non-free
  {{ if eq $suite "bookworm" }}
      - non-free-firmware
{{ end }}
    mirror: {{ $debian_mirror }}/debian
{{ else if eq $distro "ubuntu" }}
      - restricted
      - universe
      - multiverse
    mirror: {{ $ubuntu_mirror }}/ubuntu-ports
    check-gpg: false
{{ end }}

  - action: apt
    description: Prepare for custom repo
    packages:
      - curl
      - apt-transport-https
      - ca-certificates

  - action: recipe
    description: Add {{ $suite }}-updates Repo
    recipe: scripts/add_repo.yaml
    variables:
      suite: {{ $suite }}-updates
{{ if eq $distro "debian" }}
      base_url: {{ $debian_mirror }}/debian
      area: {{ $debian_area }}
{{ else if eq $distro "ubuntu" }}
      base_url: {{ $ubuntu_mirror }}/ubuntu-ports
      area: {{ $ubuntu_area }}
{{ end }}

  - action: recipe
    description: Add {{ $suite }}-backports Repo
    recipe: scripts/add_repo.yaml
    variables:
      suite: {{ $suite }}-backports
{{ if eq $distro "debian" }}
      base_url: {{ $debian_mirror }}/debian
      area: {{ $debian_area }}
{{ else if eq $distro "ubuntu" }}
      base_url: {{ $ubuntu_mirror }}/ubuntu-ports
      area: {{ $ubuntu_area }}
{{ end }}

  - action: recipe
    description: Add {{ $suite }} security update Repo
    recipe: scripts/add_repo.yaml
    variables:
{{ if eq $suite "buster" }}
      suite: {{ $suite }}/updates
      origin: {{ $suite }}-security
{{ else }}
      suite: {{ $suite }}-security
{{ end }}
{{ if eq $distro "debian" }}
      base_url: {{ $debian_mirror }}/debian-security
      area: {{ $debian_area }}
{{ else if eq $distro "ubuntu" }}
      base_url: {{ $ubuntu_mirror }}/ubuntu-ports
      area: {{ $ubuntu_area }}
{{ end }}

  - action: recipe
    description: Add Radxa Repo
    recipe: scripts/add_radxa_repo.yaml
    variables:
      origin: radxa
      suite: {{ $suite }}{{ $repo_prefix }}
      repo: {{ $suite }}{{ $repo_prefix }}
      radxa_mirror: {{ $radxa_mirror }}

  - action: recipe
    description: Install base packages
    recipe: flavors/.base.yaml
    variables:
      distro: {{ $distro }}
      suite: {{ $suite }}

  - action: recipe
    description: Clean up rootfs
    recipe: scripts/clean.yaml

  - action: pack
    description: Save rootfs
    file: .rootfs/{{ $distro }}_{{ $suite }}{{ $repo_prefix }}_base.tar